commit b1f9fb0e133e9654caecb4a6b133ce559f21ca6a
Author: Simon Martin <simon@nasilyan.com>
Date:   Sun Jan 5 10:36:47 2025 +0100

    c++: Friend classes don't shadow enclosing template class paramater [PR118255]
    
    We currently reject the following code
    
    === code here ===
    template <int non_template> struct S { friend class non_template; };
    class non_template {};
    S<0> s;
    === code here ===
    
    While EDG agrees with the current behaviour, clang and MSVC don't (see
    https://godbolt.org/z/69TGaabhd), and I believe that this code is valid,
    since the friend clause does not actually declare a type, so it cannot
    shadow anything. The fact that we didn't error out if the non_template
    class was declared before S backs this up as well.
    
    This patch fixes this by skipping the call to check_template_shadow for
    hidden bindings.
    
            PR c++/118255
    
    gcc/cp/ChangeLog:
    
            * name-lookup.cc (pushdecl): Don't call check_template_shadow
            for hidden bindings.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/lookup/pr99116-1.C: Adjust test expectation.
            * g++.dg/template/friend84.C: New test.
    
    (cherry picked from commit b5a069203fc074ab75d994c4a7e0f2db6a0a00fd)

diff --git a/gcc/cp/name-lookup.cc b/gcc/cp/name-lookup.cc
index b752598564a..309f8fdadcb 100644
--- a/gcc/cp/name-lookup.cc
+++ b/gcc/cp/name-lookup.cc
@@ -4001,7 +4001,10 @@ pushdecl (tree decl, bool hiding)
       if (old && anticipated_builtin_p (old))
 	old = OVL_CHAIN (old);
 
-      check_template_shadow (decl);
+      if (hiding)
+	; /* Hidden bindings don't shadow anything.  */
+      else
+	check_template_shadow (decl);
 
       if (DECL_DECLARES_FUNCTION_P (decl))
 	{
diff --git a/gcc/testsuite/g++.dg/lookup/pr99116-1.C b/gcc/testsuite/g++.dg/lookup/pr99116-1.C
index 01b483ea915..efee3e4aca3 100644
--- a/gcc/testsuite/g++.dg/lookup/pr99116-1.C
+++ b/gcc/testsuite/g++.dg/lookup/pr99116-1.C
@@ -2,7 +2,7 @@
 
 template<int T> struct Z {
 
-  friend struct T; // { dg-error "shadows template parameter" }
+  friend struct T; // { dg-bogus "shadows template parameter" }
 };
 
 struct Y {
